## samba 4.16.0+dfsg

=== debian/changelog ===
samba (2:4.16.0+dfsg-6.0nosystemd1) nosystemd; urgency=medium

  * remove hard dependency on libsystemd0/libelogind0 

 -- anticapitalista <antix@operamail.com>  Sun, 10 Apr 2022 10:20:52 +0300

samba (2:4.16.0+dfsg-6) unstable; urgency=medium

  * another attempt to fix/work around #221618. Re-enable
    libsmbclient-ensure-lfs-221618.patch and change it to just define
    an extra type array int[sizeof(off_t)-7]. If off_t is small it will
    become a compile error.  It is an ugly way to do it, but it should
    actually work, unlike various static_assert/_Static_assert which are
    language (C/C++) and standard-dependent.  Closes: #221618.

 -- Michael Tokarev <mjt@tls.msk.ru>  Sat, 09 Apr 2022 17:27:09 +0300

samba (2:4.16.0+dfsg-5) unstable; urgency=medium

  * disable libsmbclient-ensure-lfs-221618.patch for now.
    It throws errors in one or another configuration no matter what.
    Repoens: #221618
  * d/salsa-ci.yml: re-allow blhc salsa-ci test to fail again
    due to different bug in blhc

 -- Michael Tokarev <mjt@tls.msk.ru>  Sat, 09 Apr 2022 16:33:57 +0300

samba (2:4.16.0+dfsg-4) unstable; urgency=medium

  * libsmbclient-ensure-lfs-221618.patch: replace _Static_assert with
    static_assert (and include <assert.h> to make C++ happy too
    (Closes: #1009211)
  * disable-setuid-confchecks.patch: when running configure tests,
    samba tries to verify setuid/setgid etc calls are actually
    *working*, not just exists. This is only possible when the
    configure is running as root. But it turns out in some salsa-ci
    configuration (namely in the reprotest), the second build is
    actually running as root, and in that environment, actual
    setegid call is failing somehow. Just disable the config-time
    check for correctly working setgid and assume it "just works"
    if present, exactly like non-root build will do.
  * d/salsa-ci.yml: do not expect failure in blhc test (the original
    prob has been fixed long ago), and stop requiring experimental
  * mention closing of #999876 by 4.16

 -- Michael Tokarev <mjt@tls.msk.ru>  Sat, 09 Apr 2022 00:42:38 +0300

samba (2:4.16.0+dfsg-3) unstable; urgency=medium

  * d/control: comment out the selftest-mode build deps for now
  * d/control: forgotten python3-samba:Replaces against samba package too,
    not just samba-libs, when moving dckeytab python lib (Closes: #1009175)

 -- Michael Tokarev <mjt@tls.msk.ru>  Fri, 08 Apr 2022 10:18:23 +0300

samba (2:4.16.0+dfsg-2) unstable; urgency=medium

  * use strict versioned dependency between samba-dsdb-modules and libldb2,
    since they're tied to each other and are now built from the same source
  * fix forgotten shlib symbols generation for python3-ldb
  * change libldb versioning scheme
     from   ldb_2:2.5.0+samba4.16.0-1
     to     ldb_2:2.5.0-1+samba4.16.0
    so that symbols versioning works correctly.  Unfortunately the previous
    upload to experimental used the first form which is greather than the
    correct one, so temporarily (just for this 2.5.0 version of ldb) use
    this:   ldb_2:2.5.0+smb-1+samba4.16.0
    (with "+smb" suffix to be removed for 2.5.1+)
  * exclude samba-vfs-modules for i386 ubuntu build since this package
    is useless without samba itself (which is not built on this environment)
  * create selftest rules and add !nocheck build-dependencies
    (but do not enable selftests for now as they're failing)
  * split build system into -arch and -indep parts. We build only one arch-all
    package (samba-common) which contains only static files from debian/,
    there's no need to build whole samba to build this package.
    Move almost all Build-Depends to Build-Depends-Arch (and reindent them).
  * various updates to d/rules

 -- Michael Tokarev <mjt@tls.msk.ru>  Thu, 07 Apr 2022 09:56:56 +0300

samba (2:4.16.0+dfsg-1) experimental; urgency=medium

  * New upstream major release.
    Closes: #1004690, CVE-2021-20316: Fileserver symlink metadata share escape
    Closes: #1004691, CVE-2021-43566: mkdir race condition allows share escape
    Closes: #1004692, CVE-2021-44141: UNIX extensions in SMB1 disclose whether
     the outside target of a symlink exists
    Closes: #1005642 (windows client data corruption due to cache poisoning)
    Closes: #988197 (legacy printing support, 47d79d7e7e406f7dd2)
    Closes: #998423 (coredump connecting from macos to shares with var substs)
    Closes: #999876 (winbind allow trusted domains = no regression)
  * Notable changes in 4.16 series compared to 4.13:
    - modular VFS (see The_New_VFS.txt)
    - publishing printers in AD is more complete
    - group policies for winbindd cilents (like linux systems)
    - certificate auto enrollement in AD group policy
    - large list of improvements in samba-tool
    - SMB1 protocol has been deprecated, some subcommands has been removed
    - more consistend options/subcommands in samba commands
  * d/rules: export PYTHONHASHSEED=1. This makes lots of sporadic build-time
    debian-specific failures to go away, by preserving order of waf hashes
  * refresh patches, update build-depend versions (talloc, tdb, tevent)
  * refresh lintian-overrides files, add many new overrides
  * build-depend on python3-markdown
  * build-depend on libjson-perl for new heimdal bits
  * more consistent internal lib naming; refresh file lists everywhere
  * samba: install new rpc_* services, install samba-dcerpc
  * refresh symbols files
  * build libldb from samba sources, not from separate source
    (this moves ldb plugins from /usr/lib/$triple/ldb/plugin/ldb/ to
     /usr/lib/$triple/samba/ldb/ - the same where dsdb modules are).
  * optimizations for d/make_shlibs; also allow one to specify explicit
    version for some packages
  * as per clarifications for waf --{bundled,builtin}-libraries, remove
    now-wrong usage there. This also fixes build failures with current
    samba sources
  * d/rules: various optimizations to reduce startup costs by eliminating

