## samba 4.16.1+dfsg

=== debian/changelog ===
samba (2:4.16.1+dfsg-8~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports (no changes).

 -- Michael Tokarev <mjt@tls.msk.ru>  Tue, 07 Jun 2022 14:17:55 +0300

samba (2:4.16.1+dfsg-8) unstable; urgency=medium

  * fix the Breaks/Replaces versions in the previous upload for moving
    libsamba-utils.so, and use the same Breaks/Replaces for the -dev
    packages too

 -- Michael Tokarev <mjt@tls.msk.ru>  Tue, 07 Jun 2022 14:11:09 +0300

samba (2:4.16.1+dfsg-7) unstable; urgency=medium

  * drop libunwind-dev build dependency again: it turned out the
    internal stack unwind is better anyway
  * move libsamba-utils.so and its dependencies from libwbclient0
    into samba-libs. In the past, libwbclient were built using this
    library, but it does not depend on libsamba-utils anymore
  * d/control: libnss-winbind and libpam-winbind does not depend
    on samba-common. None of the files in samba-common are used by
    nss and pam modules; winbind does use them but not the modules.
  * d/rules: add --with-sockets-dir=/run/samba (or else it was
    /var/run/samba)

 -- Michael Tokarev <mjt@tls.msk.ru>  Tue, 07 Jun 2022 12:09:50 +0300

samba (2:4.16.1+dfsg-6) unstable; urgency=medium

  * d/control: specify arch list for libunwind-dev build-dep to be the same
    as for libunwind itself (it is not built on all architectures)

 -- Michael Tokarev <mjt@tls.msk.ru>  Sun, 29 May 2022 12:09:22 +0300

samba (2:4.16.1+dfsg-5) unstable; urgency=medium

  * add-missing-libs-deps.diff: add missing dependencies for a few samba
    libraries. Closes: #1010922
  * point [printers] to /var/tmp/, stop shipping /var/spool/samba/.
    For a long time, we shipped an alternative /var/tmp/ directory with mode
    01777 (so that anyone can use it to store files) but without the same setup
    as for regular /var/tmp/ (in particular, without removing old files and
    since it is not a usual place to store temp files, no one actually looked
    at it the same way someone would take care of /var/tmp/.  Change smb.conf
    to use /var/tmp/ instead of /var/spool/samba/. In the postinst script,
    remove /var/spool/samba/, check if it is still used in smb.conf,
    and create a compatibility symlink pointing to tmp/, suggesting changing
    smb.conf.  And remove this compat symlink in postrm.
    This probably can be accomplished by a debconf question, but the
    thing is complicated by the fact that smb.conf might be upgrading
    too at the same time.
  * debian/patches/weak-crypto-allowed-clarify.diff: update
  * testparm-do-not-fail-if-pid-dir-does-not-exist.patch: also cover samba-tool
    testparm too, not only regular stand-alone testparm.
  * fix-samba-tool-domain-join-segfault.patch: fix segfault when joining an
    AD-DC domain using samba-tool join.
  * d/rules: enable --with-profilig-data to build samba with profiling
    collection (if set in smb.conf)
  * d/control: add libunwind-dev to build-deps, to compile in stack backtrace
    logging in case of crash
  * d/control: stop build-conflicting with now-unused libtracker-miner-2.0-dev
  * d/control: stop build-conflicting with libtracker-sparql-2.0-dev: there's
    no point in explicitly disabling libtracker-sparql support (bullseye-only
    for now anyway)

 -- Michael Tokarev <mjt@tls.msk.ru>  Sat, 28 May 2022 22:50:43 +0300

samba (2:4.16.1+dfsg-4) unstable; urgency=medium

  [ Michael Tokarev ]
  * fix spelling in disable-setuid-confchecks.patch
  * d/NEWS: split it into different $package.NEWS files
  * d/upstream/metadata: add Bug-Database
  * d/samba.postinst: create sambashare group and usershare directory
    on new install only
  * libldb2: provide compat symlinks for bullseye ldb modules dir
  * d/rules: provide Build-Depends-Package: for python3-ldb
  * samba-vfs-modules.lintian-overrides: add spare-manual-page vfs_*.8 override
  * winbind.lintian-overrides: add spare-manual-page idmap_*.8 override

  [ Arnaud Rebillout ]
  * Fix patch testparm-do-not-fail-if-pid-dir-does-not-exist (Closes: #1010835)

 -- Michael Tokarev <mjt@tls.msk.ru>  Wed, 11 May 2022 09:50:03 +0300

samba (2:4.16.1+dfsg-3) unstable; urgency=medium

  * fix ldb package version generation in d/make_shlibs
    which was wrong in 2 previous uploads.
    Will I *ever* make it actually work someday?

 -- Michael Tokarev <mjt@tls.msk.ru>  Mon, 02 May 2022 18:32:24 +0300

samba (2:4.16.1+dfsg-2) unstable; urgency=medium

  * rethink ldb version *again*, to be 2.5.0+smb4.16.1-2
    or else 2.5.0+smb-1 from samba-4.16.1-2 sorts before
    2.5.0+smb-7 from samba-4.16.0-7.

 -- Michael Tokarev <mjt@tls.msk.ru>  Mon, 02 May 2022 17:02:16 +0300

samba (2:4.16.1+dfsg-1) unstable; urgency=medium

  * new upstream minor release 4.16.1
  * move-msg.sock-from-var-lib-samba-to-run-samba.patch:
    move /var/lib/samba/private/msg.sock/ to /run/samba/msg.sock/.
    This is a (private) socket directory for IPC, it should not be in /var.
  * Remove /var/lib/samba/private/msg.sock/ in postinst
  * testparm-do-not-fail-if-pid-dir-does-not-exist.patch:
    testparm deliberately fails if /run/samba does not exist,
    while testparam itself does not use it and daemons will
    create it on demand.  Just make it a warning instead of a
    fatal error, and we'll not need to pre-create this dir
    in a random place using hackish ways
  * ctdb-create-piddir.patch: create /run/ctdb/ in ctdb.service
    and ctdb.init before invoking ctdbd (as the latter does not
    create its pid directory on demand).
  * stop (ab)using tmpfiles.d to pre-create /run/samba/ and /run/ctdb/
    and stop creating /run/samba/ in samba-common-bin.postinst just to
    make testparam happy.
  * d/rules: minor tweaks

 -- Michael Tokarev <mjt@tls.msk.ru>  Mon, 02 May 2022 13:16:12 +0300

samba (2:4.16.0+dfsg-7) unstable; urgency=medium

  * another bunch of small tweaks to d/rules:
   - set SHELL to /bin/sh -e
   - rework the clean target
   - provide fast replacement of architecture.mk

