=== debian/control ===
--- 
+++ 
@@ -56,6 +56,7 @@
 	libpopt-dev,
 	librados-dev [amd64 arm64 armel armhf i386 mips64el mipsel ppc64el ppc64 s390x x32],
 	libreadline-dev,
+	libsystemd-dev [linux-any],
 	libtasn1-6-dev (>= 3.8),
 	libtasn1-bin,
 	liburing-dev [linux-any],
@@ -73,8 +74,6 @@
 #	python3-cryptography <!nocheck>,
 #	python3-iso8601 <!nocheck>,
 #	python3-pyasn1 <!nocheck>,
-Build-Conflicts: libtracker-miner-2.0-dev,
-                 libtracker-sparql-2.0-dev
 Rules-Requires-Root: binary-targets
 Vcs-Browser: https://salsa.debian.org/samba-team/samba
 Vcs-Git: https://salsa.debian.org/samba-team/samba.git
@@ -131,7 +130,11 @@
 Architecture: any
 Section: libs
 Depends: ${misc:Depends}, ${shlibs:Depends}
+Replaces:
+# libsamba-util.so &deps moved from libwbclient0 to samba-libs in 4.16.1+dfsg-7
+ libwbclient0 (<< 2:4.16.1+dfsg-7~)
 Breaks: sssd-ad-common (<< 2.3.0),
+ libwbclient0 (<< 2:4.16.1+dfsg-7~)
 Description: Samba core libraries
  Samba is an implementation of the SMB/CIFS protocol for Unix systems,
  providing support for cross-platform file sharing with Microsoft Windows, OS X,
@@ -234,6 +237,9 @@
          libwbclient-dev,
          samba-libs (= ${binary:Version}),
          ${misc:Depends}
+# libsamba-util.so moved from libwbclient0 to samba-libs in 4.16.1+dfsg-7
+Replaces: libwbclient-dev (<< 2:4.16.1+dfsg-7~)
+Breaks:   libwbclient-dev (<< 2:4.16.1+dfsg-7~)
 Section: devel
 Description: tools for extending Samba
  Samba is an implementation of the SMB/CIFS protocol for Unix systems,
@@ -328,13 +334,3 @@
 Description: development files for libsmbclient
  This package provides the development files (static library and headers)
  required for building applications against libsmbclient, a library that
- enables client applications to talk to Microsoft Windows and Samba servers
- using the SMB/CIFS protocol.
-
-Package: winbind
-Pre-Depends: ${misc:Pre-Depends}
-Architecture: any
-Multi-Arch: allowed
-Depends: lsb-base (>= 3.0-6),
-         samba-common (= ${source:Version}),
-         samba-common-bin (=${binary:Version}),
