=== debian/rules ===
--- 
+++ 
@@ -1,70 +1,71 @@
 #!/usr/bin/make -f
+SHELL = /bin/sh -e
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/buildflags.mk
 include /usr/share/dpkg/pkg-info.mk
 include /usr/share/dpkg/vendor.mk
-# faster version of dpkg/architecture.mk defining only vars we actually need
-$(foreach var,DEB_HOST_ARCH DEB_HOST_ARCH_OS DEB_HOST_MULTIARCH,\
-	$(eval export ${var} ?= $$(shell dpkg-architecture -q${var})))
+# Fast version of dpkg/architecture.mk defining all vars in one go
+ifeq (${DEB_HOST_MULTIARCH},)
+   $(foreach d, $(shell dpkg-architecture | sed 's/=/?=/'), $(eval export $d))
+endif
 
 export PYTHON = python3
-
-# just the debian revision number from the package version
-DEB_REVISION = $(call dpkg_late_eval,DEB_REVISION,v='${DEB_VERSION}'; echo "$${v##*-}")
 
 LDB_EPOCH := 2:
 LDB_VERSION = $(call dpkg_late_eval,LDB_VERSION,grep ^VERSION lib/ldb/wscript | cut -d\' -f2)
  # For 2.5.0 we uploaded wrongly versioned ldb to experimental (2.5.0+samba should be 2.5.0)
  # Temporarily add a suffix so it sorts after the wrong version. Remove for 2.5.1+.
-LDB_DEB_VERSION := ${LDB_EPOCH}${LDB_VERSION}$(if $(filter ${LDB_VERSION},2.5.0),+smb)-${DEB_REVISION}+samba${DEB_VERSION_UPSTREAM}
+ifneq (${LDB_VERSION}, 2.5.0)
+$(error update LDB version number expression below:)
+endif
+LDB_DEB_VERSION := ${LDB_EPOCH}${LDB_VERSION}+smb$(subst +dfsg,,${DEB_VERSION_UPSTREAM_REVISION})
 LDB_DEPENDS := libldb2 (= ${LDB_DEB_VERSION})
+LDB_PACKAGES := libldb2 libldb-dev ldb-tools python3-ldb python3-ldb-dev
 
 V = 1
-WAF_CMD := PYTHONHASHSEED=1 ${PYTHON} ./buildtools/bin/waf
-WAF := ${WAF_CMD} $(if ${V},-v)
-
-ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
-    WAF += -j $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
-endif
+WAF := PYTHONHASHSEED=1 ${PYTHON} ./buildtools/bin/waf \
+	$(subst parallel=,-j,$(filter parallel=%,${DEB_BUILD_OPTIONS}))
+WAFv := ${WAF} $(if $V, -v)
 
 conf_args = \
-		--prefix=/usr \
-		--enable-fhs \
-		--sysconfdir=/etc \
-		--localstatedir=/var \
-		--libexecdir=/usr/libexec \
-		--with-privatedir=/var/lib/samba/private \
-		--with-smbpasswd-file=/etc/samba/smbpasswd \
-		--with-piddir=/run/samba \
-		--with-pammodulesdir=/lib/$(DEB_HOST_MULTIARCH)/security \
-		--with-pam \
-		--with-syslog \
-		--with-utmp \
-		--with-winbind \
-		--with-quota \
-		--with-shared-modules=idmap_rid,idmap_ad,idmap_adex,idmap_hash,idmap_ldap,idmap_tdb2,vfs_dfs_samba4,auth_samba4,vfs_nfs4acl_xattr \
-		--with-automount \
-		--with-ldap \
-		--with-ads \
-		--with-gpgme \
-		--libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
-		--with-modulesdir=/usr/lib/$(DEB_HOST_MULTIARCH)/samba \
-		--datadir=/usr/share \
-		--with-lockdir=/run/samba \
-		--with-statedir=/var/lib/samba \
-		--with-cachedir=/var/cache/samba \
-		--enable-avahi \
-		--disable-rpath \
-		--disable-rpath-install \
-		--bundled-libraries=NONE,pytevent,ldb \
-		--with-cluster-support \
-		--with-socketpath=/run/ctdb/ctdbd.socket \
-		--with-logdir=/var/log/ctdb \
-		--enable-etcd-reclock \
-		--enable-spotlight
-
+	--prefix=/usr \
+	--enable-fhs \
+	--sysconfdir=/etc \
+	--localstatedir=/var \
+	--libexecdir=/usr/libexec \
+	--libdir=/usr/lib/${DEB_HOST_MULTIARCH} \
+	--datadir=/usr/share \
+	--with-modulesdir=/usr/lib/${DEB_HOST_MULTIARCH}/samba \
+	--with-pammodulesdir=/lib/${DEB_HOST_MULTIARCH}/security \
+	--with-privatedir=/var/lib/samba/private \
+	--with-smbpasswd-file=/etc/samba/smbpasswd \
+	--with-piddir=/run/samba \
+	--with-lockdir=/run/samba \
+	--with-sockets-dir=/run/samba \
+	--with-statedir=/var/lib/samba \
+	--with-cachedir=/var/cache/samba \
+	--with-pam \
+	--with-syslog \
+	--with-utmp \
+	--with-winbind \
+	--with-quota \
+	--with-automount \
+	--with-ldap \
+	--with-ads \
+	--with-gpgme \
+	--enable-avahi \
+	--enable-spotlight \
+	--with-profiling-data \
+	--disable-rpath --disable-rpath-install \
+	--with-shared-modules=idmap_rid,idmap_ad,idmap_adex,idmap_hash,idmap_ldap,idmap_tdb2,vfs_dfs_samba4,auth_samba4,vfs_nfs4acl_xattr \
+	--bundled-libraries=NONE,pytevent,ldb \
+	\
+	--with-cluster-support \
+	--enable-etcd-reclock \
+	--with-socketpath=/run/ctdb/ctdbd.socket \
+	--with-logdir=/var/log/ctdb \
 
 WITH_CEPH = yes
 # Ceph is not available on all platforms
@@ -76,44 +77,41 @@
     WITH_CEPH =
 endif
 
-ifneq ($(WITH_CEPH),)
-	conf_args += \
-		--enable-ceph-reclock
-else
-	conf_args += \
-		--disable-cephfs
-endif
-
+conf_args += $(if ${WITH_CEPH},\
+	--enable-cephfs --enable-ceph-reclock,\
+	--disable-cephfs)
 
 WITH_GLUSTERFS = yes
 # GlusterFS is linux-only
 ifneq ($(DEB_HOST_ARCH_OS), linux)
     WITH_GLUSTERFS =
 endif
-# GlusterFS is not in Ubuntu main
-ifeq ($(DEB_VENDOR), Ubuntu)
-    WITH_GLUSTERFS =
+
+ifeq ($(DEB_HOST_ARCH_OS), linux)
+conf_args += \
+	--with-systemd \
+	--systemd-install-services \
+	--with-systemddir=/lib/systemd/system
+else
+conf_args += --without-systemd
 endif
 
-ifeq ($(DEB_HOST_ARCH_OS), linux)
-	conf_args += \
-		--without-systemd
-else
-	conf_args += \
-		--without-systemd
+# Ubuntu i386 binary compatibility only effort: Disable some i386 packages
+ifeq ($(DEB_VENDOR) $(DEB_HOST_ARCH), Ubuntu i386)
+export DH_OPTIONS += $(addprefix -N,\
+	ctdb libpam-winbind samba samba-testsuite samba-vfs-modules )
 endif
-
 # build_pakages will honour arch/indep and the above disabled list
 build_packages := $(shell dh_listpackages)
 
 binary binary-arch binary-indep \
-clean install install-arch install-indep: %:
+install install-arch install-indep: %:
 	dh $*
 
 configure: bin/configured.stamp
 .PHONY: configure
 bin/configured.stamp:
-	${WAF_CMD} -j 1 configure ${conf_args} || \
+	${WAF} -j1 configure -C ${conf_args} || \
 	  { $(if ${V},echo "==== contents of config.log:"; cat bin/config.log;) false; }
 	touch $@
 
@@ -131,8 +129,8 @@
 # This will pefrorm unnecessary/extra install step (into d/tmp), which
 # we'll repeat during actual install stage, but this is definitely
 # better/faster than building whole thing for _not_ running from the build dir.
-	${WAF} --targets=compile_et,asn1_compile
-	${WAF} install --destdir="${CURDIR}/debian/tmp"
+	${WAFv} --targets=compile_et,asn1_compile
+	${WAFv} install --destdir="${CURDIR}/debian/tmp"
 	touch $@
 build-indep:
 build: build-arch build-indep
@@ -145,7 +143,7 @@
 
 testbuild/copied.stamp:
 	rm -rf testbuild; mkdir testbuild
-	cp -a -l $$(ls -1 | egrep -v '^(bin|testbuild)$$') testbuild/
+	cp -a -l $$(ls -1 | egrep -v '^(bin|testbuild|debian)$$') testbuild/
 # cleanup some files just in case, do not interfere with production build
 	find testbuild -name __pycache__ -exec rm -rf {} +
 	rm -f testbuild/compile_commands.json
@@ -156,7 +154,7 @@
 # (libsocket-wrapper &Co), but let's just build the bundled ones. There's no
 # good reason to use externally-packaged wrappers, they're small to build and
 # we don't use them for production build, and extra versioned build-dep hurts.
-	cd testbuild && ${WAF_CMD} -j 1 configure --enable-selftest -C \
+	cd testbuild && ${WAF} -j1 configure --enable-selftest -C \
 		$$(echo '${conf_args}' | \
 		   sed 's|--bundled-libraries=NONE|&,nss_wrapper,pam_wrapper,resolv_wrapper,socket_wrapper,uid_wrapper|')
 # FIXME: some tests fail for now, handle them later
@@ -192,5 +190,3 @@
 	install -p -m755 debian/update-apparmor-samba-profile -t debian/tmp/usr/share/samba/
 	install -p -m0755 debian/mksmbpasswd.awk debian/tmp/usr/sbin/mksmbpasswd
 	install -Dp -m0644 debian/samba.ufw.profile debian/tmp/etc/ufw/applications.d/samba
-	install -Dp -m0644 debian/source_samba.py -t debian/tmp/usr/share/apport/package-hooks/
-
