=== debian/watch ===
version=4
opts=uversionmangle=s/tp/~alpha1~tp/;s/alpha/~alpha/;s/beta/~beta/;s/rc/~rc/,dversionmangle=s/\+dfsg\d*$//,pgpsigurlmangle=s/tar\.gz/tar.asc/,decompress https://download.samba.org/pub/samba/ samba-(4\.16\..*).tar.gz
